﻿using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;

namespace dbd
{
    public class Mod
    {
        public static void Main()
        {

            {

                CategoryBuilder.Create("Dead by Daylight", "Dead by Daylight Mod", ModAPI.LoadSprite("icons/dbd.png"));

                ModAPI.Register(
                      new Modification()
                      {
                          OriginalItem = ModAPI.FindSpawnable("Sword"),
                          NameOverride = "The Cleaver -DBD",
                          DescriptionOverride = "A brutal cleaver, hammered by his own hands from the metals of the mine..",
                          CategoryOverride = ModAPI.FindCategory("Dead by Daylight"),
                          ThumbnailOverride = ModAPI.LoadSprite("icons/trapperweaponicon.png", 22f),
                          AfterSpawn = (Instance) =>
                          {
                              Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("weapons/trapperweapon.png", 2.7f);
                              Instance.FixColliders();
                          }
                      }
                  );
                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Hammer"),
                        NameOverride = "Azarov's Skull -DBD",
                        DescriptionOverride = "Azarov's Skull is the primary weapon of the Wraith. The teeth of death lie on Azarov's skull and spine..",
                        CategoryOverride = ModAPI.FindCategory("Dead by Daylight"),
                        ThumbnailOverride = ModAPI.LoadSprite("icons/wraithweaponicon.png", 22f),
                        AfterSpawn = (Instance) =>
                        {
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("weapons/wraithweapon.png", 3.4f);
                            Instance.FixColliders();
                        }
                    }
                );
                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Hammer"),
                        NameOverride = "Brutal Cattle Hammer -DBD",
                        DescriptionOverride = "The Hammer is the primary weapon of the Hillbilly. The cattle hammer deals a sharp blow to the skull as the most effective manner of slaughter.",
                        CategoryOverride = ModAPI.FindCategory("Dead by Daylight"),
                        ThumbnailOverride = ModAPI.LoadSprite("icons/hillbillyweaponicon.png", 22f),
                        AfterSpawn = (Instance) =>
                        {
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("weapons/hillbillyweapon.png", 3.5f);
                            Instance.FixColliders();
                        }
                    }
                );
                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Sword"),
                        NameOverride = "Nurse's Bonesaw -DBD",
                        DescriptionOverride = "The Bonesaw is the primary weapon of the Nurse. Rusty metal implement for tearing through flesh and bone.",
                        CategoryOverride = ModAPI.FindCategory("Dead by Daylight"),
                        ThumbnailOverride = ModAPI.LoadSprite("icons/nurseweaponicon.png", 22f),
                        AfterSpawn = (Instance) =>
                        {
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("weapons/nurseweapon.png", 3f);
                            Instance.FixColliders();
                        }
                    }
                );
                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Sword"),
                        NameOverride = "Kitchen Knife -DBD",
                        DescriptionOverride = "The Kitchen Knife is The Shape's primary weapon: an oversized blade with devastatingly sharp edges.",
                        CategoryOverride = ModAPI.FindCategory("Dead by Daylight"),
                        ThumbnailOverride = ModAPI.LoadSprite("icons/shapeweaponicon.png", 22f),
                        AfterSpawn = (Instance) =>
                        {
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("weapons/shapeweapon.png", 3.1f);
                            Instance.FixColliders();
                        }
                    }
                );
                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Hammer"),
                        NameOverride = "The Stick -DBD",
                        DescriptionOverride = "The Stick is the primary weapon for The Doctor. An instrument of punishment when all other treatments failed..",
                        CategoryOverride = ModAPI.FindCategory("Dead by Daylight"),
                        ThumbnailOverride = ModAPI.LoadSprite("icons/doctorweaponicon.png", 22f),
                        AfterSpawn = (Instance) =>
                        {
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("weapons/doctorweapon.png", 3.2f);
                            Instance.FixColliders();
                        }
                    }
                );
                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Hammer"),
                        NameOverride = "The Sledge -DBD",
                        DescriptionOverride = "The Sledge is the Primary Weapon of The Cannibal. The Sledge might be old-fashioned but it is still the fastest and cleanest way to put down cattle..",
                        CategoryOverride = ModAPI.FindCategory("Dead by Daylight"),
                        ThumbnailOverride = ModAPI.LoadSprite("icons/bubbaweaponicon.png", 22f),
                        AfterSpawn = (Instance) =>
                        {
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("weapons/bubbaweapon.png", 3.3f);
                            Instance.FixColliders();
                        }
                    }
                );
                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Knife"),
                        NameOverride = "Hidden Blade -DBD",
                        DescriptionOverride = "A razor-sharp blade, attached to a mechanical contraption that can conceal or extend it.",
                        CategoryOverride = ModAPI.FindCategory("Dead by Daylight"),
                        ThumbnailOverride = ModAPI.LoadSprite("icons/pigweaponicon.png", 22f),
                        AfterSpawn = (Instance) =>
                        {
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("weapons/pigweapon.png", 3.7f);
                            Instance.FixColliders();
                        }
                    }
                );
                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Knife"),
                        NameOverride = "Madame Butterfly -DBD",
                        DescriptionOverride = "Madame Butterfly is the Primary Weapon of The Clown. An oversized butterfly knife, as accustomed to inflicting torture and pain as it is to removing limbs and appendages.",
                        CategoryOverride = ModAPI.FindCategory("Dead by Daylight"),
                        ThumbnailOverride = ModAPI.LoadSprite("icons/clownweaponicon.png", 22f),
                        AfterSpawn = (Instance) =>
                        {
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("weapons/clownweapon.png", 3.5f);
                            Instance.FixColliders();
                        }
                    }
                );
                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Sword"),
                        NameOverride = "Shattered Katana -DBD",
                        DescriptionOverride = "A single-edged straight sword handed down from generation to generation. The blade shattered after spilling the blood of her kin.",
                        CategoryOverride = ModAPI.FindCategory("Dead by Daylight"),
                        ThumbnailOverride = ModAPI.LoadSprite("icons/spiritweaponicon.png", 22f),
                        AfterSpawn = (Instance) =>
                        {
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("weapons/spiritweapon.png", 4.9f);
                            Instance.FixColliders();
                        }
                    }
                );
                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Knife"),
                        NameOverride = "Hunting Knife -DBD",
                        DescriptionOverride = "Hunting Knife.",
                        CategoryOverride = ModAPI.FindCategory("Dead by Daylight"),
                        ThumbnailOverride = ModAPI.LoadSprite("icons/legionweaponicon.png", 22f),
                        AfterSpawn = (Instance) =>
                        {
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("weapons/legionweapon.png", 3.6f);
                            Instance.FixColliders();
                        }
                    }
                );
                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Knife"),
                        NameOverride = "Tactical Knife -DBD",
                        DescriptionOverride = "The Tactical Knife is the Primary Weapon of The Ghost Face. See how the streetlights glint on the razor-sharp edge? Anyone should feel honoured to feel it sliding through their ribcage.",
                        CategoryOverride = ModAPI.FindCategory("Dead by Daylight"),
                        ThumbnailOverride = ModAPI.LoadSprite("icons/ghostfaceweaponicon.png", 22f),
                        AfterSpawn = (Instance) =>
                        {
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("weapons/ghostfaceweapon.png", 3.6f);
                            Instance.FixColliders();
                        }
                    }
                );
                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Sword"),
                        NameOverride = "Yamaoka Blade -DBD",
                        DescriptionOverride = "A long blade that was passed down from one generation to the next.",
                        CategoryOverride = ModAPI.FindCategory("Dead by Daylight"),
                        ThumbnailOverride = ModAPI.LoadSprite("icons/oniweaponicon.png", 22f),
                        AfterSpawn = (Instance) =>
                        {
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("weapons/oniweapon.png", 3.6f);
                            Instance.FixColliders();
                        }
                    }
                );
                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Sword"),
                        NameOverride = "Death to Bayshore (Doesn't Shoot) -DBD",
                        DescriptionOverride = "A sharp weapon with a strong bite.",
                        CategoryOverride = ModAPI.FindCategory("Dead by Daylight"),
                        ThumbnailOverride = ModAPI.LoadSprite("icons/deathslingerweaponicon.png", 22f),
                        AfterSpawn = (Instance) =>
                        {
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("weapons/deathslingerweapon.png", 3.4f);
                            Instance.FixColliders();
                        }
                    }
                );
                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Sword"),
                        NameOverride = "Great Knife -DBD",
                        DescriptionOverride = "A massive chef's knife to reap affliction and misery from his victims.",
                        CategoryOverride = ModAPI.FindCategory("Dead by Daylight"),
                        ThumbnailOverride = ModAPI.LoadSprite("icons/pyramidheadweaponicon.png", 22f),
                        AfterSpawn = (Instance) =>
                        {
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("weapons/pyramidheadweapon.png", 3.5f);
                            Instance.FixColliders();
                        }
                    }
                );
                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = "Trapper W.I.P. -DBD",
                        DescriptionOverride = "How many victims fell to the hands of father and son is unknown. No record is ever made of what became of Evan MacMillan. His father is another unsolved puzzle, found trapped in the locked basement of his own warehouse - starved and abandoned.",
                        CategoryOverride = ModAPI.FindCategory("Dead by Daylight"),
                        ThumbnailOverride = ModAPI.LoadSprite("icons/trappericon.png", 22f),
                        AfterSpawn = (Instance) =>
                        {
                            //load textures for each layer (see Human textures folder in this repository)
                            var skin = ModAPI.LoadTexture("characters/trapper.png");


                            //get person
                            var person = Instance.GetComponent<PersonBehaviour>();

                            //use the helper function to set each texture
                            //parameters are as follows: 
                            //  skin texture, flesh texture, bone texture, sprite scale
                            //you can pass "null" to fall back to the original texture
                            person.SetBodyTextures(skin, null, null, 1);

                            //change procedural damage colours if they interfere with your texture (rgb 0-255)
                            person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                            person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                            person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                            person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                            person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                            foreach (var body in person.Limbs)
                            {

                                body.BaseStrength *= 1f;
                                body.Health *= 2f;
                                body.BreakingThreshold *= 2f;
                            }
                        }

                    }
                );
                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = "Wraith W.I.P. -DBD",
                        DescriptionOverride = "Ojomo snapped and went ballistic. He threw his boss in the crusher and let it slowly compress, as the head stuck out, Ojomo grabbed it and pulled head and spine out of the body. Then he left and was never seen again.",
                        CategoryOverride = ModAPI.FindCategory("Dead by Daylight"),
                        ThumbnailOverride = ModAPI.LoadSprite("icons/wraithicon.png", 22f),
                        AfterSpawn = (Instance) =>
                        {
                            //load textures for each layer (see Human textures folder in this repository)
                            var skin = ModAPI.LoadTexture("characters/wraith.png");


                            //get person
                            var person = Instance.GetComponent<PersonBehaviour>();

                            //use the helper function to set each texture
                            //parameters are as follows: 
                            //  skin texture, flesh texture, bone texture, sprite scale
                            //you can pass "null" to fall back to the original texture
                            person.SetBodyTextures(skin, null, null, 1);

                            //change procedural damage colours if they interfere with your texture (rgb 0-255)
                            person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                            person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                            person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                            person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                            person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                            foreach (var body in person.Limbs)
                            {

                                body.BaseStrength *= 1f;
                                body.Health *= 2f;
                                body.BreakingThreshold *= 2f;
                            }
                        }

                    }
                ); ModAPI.Register(
                     new Modification()
                     {
                         OriginalItem = ModAPI.FindSpawnable("Human"),
                         NameOverride = "Hillbilly W.I.P. -DBD",
                         DescriptionOverride = "Coldwind Farm was quickly settled and the land split up and sold off. There was never a buyer for the farmhouse. Perhaps it was the sound of the chainsaw you could hear throughout those hot summer nights.",
                         CategoryOverride = ModAPI.FindCategory("Dead by Daylight"),
                         ThumbnailOverride = ModAPI.LoadSprite("icons/hillbillyicon.png", 22f),
                         AfterSpawn = (Instance) =>
                         {
                             //load textures for each layer (see Human textures folder in this repository)
                             var skin = ModAPI.LoadTexture("characters/hillbilly.png");


                             //get person
                             var person = Instance.GetComponent<PersonBehaviour>();

                             //use the helper function to set each texture
                             //parameters are as follows: 
                             //  skin texture, flesh texture, bone texture, sprite scale
                             //you can pass "null" to fall back to the original texture
                             person.SetBodyTextures(skin, null, null, 1);

                             //change procedural damage colours if they interfere with your texture (rgb 0-255)
                             person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                             person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                             person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                             person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                             person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                             foreach (var body in person.Limbs)
                             {

                                 body.BaseStrength *= 1f;
                                 body.Health *= 2f;
                                 body.BreakingThreshold *= 2f;
                             }
                         }

                     }
                 );
                ModAPI.Register(
                     new Modification()
                     {
                         OriginalItem = ModAPI.FindSpawnable("Human"),
                         NameOverride = "Nurse W.I.P. -DBD",
                         DescriptionOverride = "They got her into an ambulance, but that ambulance never reached the hospital. It was found crashed in a nearby wood, all the staff dead and Sally nowhere to be found..",
                         CategoryOverride = ModAPI.FindCategory("Dead by Daylight"),
                         ThumbnailOverride = ModAPI.LoadSprite("icons/nurseicon.png", 22f),
                         AfterSpawn = (Instance) =>
                         {
                             //load textures for each layer (see Human textures folder in this repository)
                             var skin = ModAPI.LoadTexture("characters/nurse.png");


                             //get person
                             var person = Instance.GetComponent<PersonBehaviour>();

                             //use the helper function to set each texture
                             //parameters are as follows: 
                             //  skin texture, flesh texture, bone texture, sprite scale
                             //you can pass "null" to fall back to the original texture
                             person.SetBodyTextures(skin, null, null, 1);

                             //change procedural damage colours if they interfere with your texture (rgb 0-255)
                             person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                             person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                             person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                             person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                             person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                             foreach (var body in person.Limbs)
                             {

                                 body.BaseStrength *= 1f;
                                 body.Health *= 2f;
                                 body.BreakingThreshold *= 2f;
                             }
                         }

                     }
                 );
                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Rod"),
                        NameOverride = "Huntress Mask -DBD",
                        DescriptionOverride = "Don't be afraid child. The gentle Hare will take good care of you..",
                        CategoryOverride = ModAPI.FindCategory("Dead by Daylight"),
                        ThumbnailOverride = ModAPI.LoadSprite("icons/huntressmaskicon.png", 22f),
                        AfterSpawn = (Instance) =>
                        {
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("armors/huntressmask.png", 1.2f);
                            ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                            armor.stabResistance = 1f;
                            armor.armorPiece = "Head";
                            armor.armorTier = 0;

                            Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.01f;
                            Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.01f;
                            Instance.FixColliders();
                        }
                    }
                );
                ModAPI.Register(
                     new Modification()
                     {
                         OriginalItem = ModAPI.FindSpawnable("Human"),
                         NameOverride = "Huntress W.I.P. -DBD",
                         DescriptionOverride = "Once the war was over, the rumours of The Huntress disappeared with it, engulfed by the Red Forest.",
                         CategoryOverride = ModAPI.FindCategory("Dead by Daylight"),
                         ThumbnailOverride = ModAPI.LoadSprite("icons/huntressicon.png", 22f),
                         AfterSpawn = (Instance) =>
                         {
                             //load textures for each layer (see Human textures folder in this repository)
                             var skin = ModAPI.LoadTexture("characters/huntress.png");


                             //get person
                             var person = Instance.GetComponent<PersonBehaviour>();

                             //use the helper function to set each texture
                             //parameters are as follows: 
                             //  skin texture, flesh texture, bone texture, sprite scale
                             //you can pass "null" to fall back to the original texture
                             person.SetBodyTextures(skin, null, null, 1);

                             //change procedural damage colours if they interfere with your texture (rgb 0-255)
                             person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                             person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                             person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                             person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                             person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                             foreach (var body in person.Limbs)
                             {

                                 body.BaseStrength *= 1f;
                                 body.Health *= 2f;
                                 body.BreakingThreshold *= 2f;
                             }
                         }

                     }
                 );
                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Rod"),
                        NameOverride = "Trapper Mask -DBD",
                        DescriptionOverride = "A twisted, soulless mask hides the bearer's face. What became of the man behind the mask?",
                        CategoryOverride = ModAPI.FindCategory("Dead by Daylight"),
                        ThumbnailOverride = ModAPI.LoadSprite("icons/trappermaskicon.png", 22f),
                        AfterSpawn = (Instance) =>
                        {
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("armors/trappermask.png", 1.2f);
                            ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                            armor.stabResistance = 1f;
                            armor.armorPiece = "Head";
                            armor.armorTier = 0;

                            Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.01f;
                            Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.01f;
                            Instance.FixColliders();
                        }
                    }
                );
                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Rod"),
                        NameOverride = "Shape Mask -DBD",
                        DescriptionOverride = "An expressionless, white latex Halloween mask.",
                        CategoryOverride = ModAPI.FindCategory("Dead by Daylight"),
                        ThumbnailOverride = ModAPI.LoadSprite("icons/shapemaskicon.png", 22f),
                        AfterSpawn = (Instance) =>
                        {
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("armors/shapemask.png", 1.2f);
                            ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                            armor.stabResistance = 1f;
                            armor.armorPiece = "Head";
                            armor.armorTier = 0;

                            Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.01f;
                            Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.01f;
                            Instance.FixColliders();
                        }
                    }
                );
                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = "The Shape W.I.P. -DBD",
                        DescriptionOverride = "People hoped that Michael Myers would end up a parenthesis, soon to be forgotten and buried, a failure that soon were to rot away. But then...he escaped.",
                        CategoryOverride = ModAPI.FindCategory("Dead by Daylight"),
                        ThumbnailOverride = ModAPI.LoadSprite("icons/shapeicon.png", 22f),
                        AfterSpawn = (Instance) =>
                        {
                            //load textures for each layer (see Human textures folder in this repository)
                            var skin = ModAPI.LoadTexture("characters/shape.png");


                            //get person
                            var person = Instance.GetComponent<PersonBehaviour>();

                            //use the helper function to set each texture
                            //parameters are as follows: 
                            //  skin texture, flesh texture, bone texture, sprite scale
                            //you can pass "null" to fall back to the original texture
                            person.SetBodyTextures(skin, null, null, 1);

                            //change procedural damage colours if they interfere with your texture (rgb 0-255)
                            person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                            person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                            person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                            person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                            person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                            foreach (var body in person.Limbs)
                            {

                                body.BaseStrength *= 1f;
                                body.Health *= 2f;
                                body.BreakingThreshold *= 2f;
                            }
                        }

                    }
                );
                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = "The Doctor W.I.P. -DBD",
                        DescriptionOverride = "Over the years, Herman became known as The Doctor and no one ever questioned if he had even held a medical certificate or even what happened to the prisoners after they had given up their information. It was only after Léry's Memorial Institute went silent for a week that the true horror was finally discovered. The personnel, patients, and prisoners were all found dead with all types of head trauma. All personnel and prisoners' bodies were accounted for, including Dr Stamper, but no sign of Herman “The Doctor” Carter.",
                        CategoryOverride = ModAPI.FindCategory("Dead by Daylight"),
                        ThumbnailOverride = ModAPI.LoadSprite("icons/doctoricon.png", 22f),
                        AfterSpawn = (Instance) =>
                        {
                            //load textures for each layer (see Human textures folder in this repository)
                            var skin = ModAPI.LoadTexture("characters/doctor.png");


                            //get person
                            var person = Instance.GetComponent<PersonBehaviour>();

                            //use the helper function to set each texture
                            //parameters are as follows: 
                            //  skin texture, flesh texture, bone texture, sprite scale
                            //you can pass "null" to fall back to the original texture
                            person.SetBodyTextures(skin, null, null, 1);

                            //change procedural damage colours if they interfere with your texture (rgb 0-255)
                            person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                            person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                            person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                            person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                            person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                            foreach (var body in person.Limbs)
                            {

                                body.BaseStrength *= 1f;
                                body.Health *= 2f;
                                body.BreakingThreshold *= 2f;
                            }
                        }

                    }
                );
                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = "The Cannibal W.I.P. -DBD",
                        DescriptionOverride = "There would be screaming, but he could make the world quiet again. Until the only sound remaining was the blessed howl of the saw.",
                        CategoryOverride = ModAPI.FindCategory("Dead by Daylight"),
                        ThumbnailOverride = ModAPI.LoadSprite("icons/bubbaicon.png", 22f),
                        AfterSpawn = (Instance) =>
                        {
                            //load textures for each layer (see Human textures folder in this repository)
                            var skin = ModAPI.LoadTexture("characters/bubba.png");


                            //get person
                            var person = Instance.GetComponent<PersonBehaviour>();

                            //use the helper function to set each texture
                            //parameters are as follows: 
                            //  skin texture, flesh texture, bone texture, sprite scale
                            //you can pass "null" to fall back to the original texture
                            person.SetBodyTextures(skin, null, null, 1);

                            //change procedural damage colours if they interfere with your texture (rgb 0-255)
                            person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                            person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                            person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                            person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                            person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                            foreach (var body in person.Limbs)
                            {

                                body.BaseStrength *= 1f;
                                body.Health *= 2f;
                                body.BreakingThreshold *= 2f;
                            }
                        }

                    }
                );
                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Rod"),
                        NameOverride = "Cannibal Mask -DBD",
                        DescriptionOverride = "A terrifying mask of dried skin, stretched and stitched together. A relic of detached faces, frozen in fear.",
                        CategoryOverride = ModAPI.FindCategory("Dead by Daylight"),
                        ThumbnailOverride = ModAPI.LoadSprite("icons/bubbamaskicon.png", 22f),
                        AfterSpawn = (Instance) =>
                        {
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("armors/bubbamask.png", 1.2f);
                            ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                            armor.stabResistance = 1f;
                            armor.armorPiece = "Head";
                            armor.armorTier = 0;

                            Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.01f;
                            Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.01f;
                            Instance.FixColliders();
                        }
                    }
                );
                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Rod"),
                        NameOverride = "Dwight Glasses -DBD",
                        DescriptionOverride = "The everyday, clean shaven Dwight ready for a day at work.",
                        CategoryOverride = ModAPI.FindCategory("Dead by Daylight"),
                        ThumbnailOverride = ModAPI.LoadSprite("icons/dwitghtglassesicon.png", 22f),
                        AfterSpawn = (Instance) =>
                        {
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("armors/dwightglasses.png", 1.2f);
                            ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                            armor.stabResistance = 1f;
                            armor.armorPiece = "Head";
                            armor.armorTier = 0;

                            Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.01f;
                            Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.01f;
                            Instance.FixColliders();
                        }
                    }
                );
                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = "Dwight Fairfield W.I.P. -DBD",
                        DescriptionOverride = "Dwight Fairfield is a nervous Leader, able to locate his allies and increase their effectiveness.",
                        CategoryOverride = ModAPI.FindCategory("Dead by Daylight"),
                        ThumbnailOverride = ModAPI.LoadSprite("icons/dwighticon.png", 22f),
                        AfterSpawn = (Instance) =>
                        {
                            //load textures for each layer (see Human textures folder in this repository)
                            var skin = ModAPI.LoadTexture("characters/dwight.png");


                            //get person
                            var person = Instance.GetComponent<PersonBehaviour>();

                            //use the helper function to set each texture
                            //parameters are as follows: 
                            //  skin texture, flesh texture, bone texture, sprite scale
                            //you can pass "null" to fall back to the original texture
                            person.SetBodyTextures(skin, null, null, 1);

                            //change procedural damage colours if they interfere with your texture (rgb 0-255)
                            person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                            person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                            person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                            person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                            person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                            foreach (var body in person.Limbs)
                            {

                                body.BaseStrength *= 1f;
                                body.Health *= 2f;
                                body.BreakingThreshold *= 2f;
                            }
                        }

                    }
                );
                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Rod"),
                        NameOverride = "Medkit -DBD",
                        DescriptionOverride = "A rudimentary First Aid Kit which can save lives in emergencies, even if it's lacking some of its supplies.",
                        CategoryOverride = ModAPI.FindCategory("Dead by Daylight"),
                        ThumbnailOverride = ModAPI.LoadSprite("icons/medkiticon.png", 22f),
                        AfterSpawn = (Instance) =>
                        {
                            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("items/medkit.png", 1.2f);
                            Instance.FixColliders();
                        }
                    }
                );
            }
        }
    }
}